#!/usr/bin/env python
# -*- coding: UTF-8 -*-
from django.shortcuts import render_to_response, get_object_or_404
from django import template
from django.http import HttpResponseRedirect
from django.core.urlresolvers import reverse

from forms import {{ Model }}Form
from models import {{ Model }}

def list(request, template_name = '{{ model }}/list.html'):
    return render_to_response(template_name, {
            "{{ model }}s": {{ Model }}.objects.all(),
            }, context_instance=template.RequestContext(request))

def new(request, form_class={{ Model }}Form, template_name = '{{ model }}/new.html'):
    if request.method == "POST":
        form = form_class(request.POST)
        if form.is_valid():
            {{ model }} = form.save(commit=False)
            {{ model }}.save()
            return HttpResponseRedirect(reverse("{{ model }}_list"))
    else:
        form = form_class()
    return render_to_response(template_name, \
            { "form": form }, \
            context_instance=template.RequestContext(request))

def edit(request, id, form_class={{ Model }}Form, template_name="{{ model }}/edit.html"):
    {{ model }} = get_object_or_404({{ Model }}, id=id)
    if request.method == "POST":
        form = form_class(request.POST, instance={{ model }})
        if form.is_valid():
            {{ model }} = form.save(commit=False)
            {{ model }}.save()
            return HttpResponseRedirect(reverse("{{ model }}_list"))
    else:
        form = form_class(instance={{ model }})
    return render_to_response(template_name, {
            "form": form, 
            "{{ model }}": {{ model }},
            }, context_instance=template.RequestContext(request))

def delete(request, id):
    {{ model }} = get_object_or_404({{ Model }}, id=id)
    {{ model }}.delete()
    return HttpResponseRedirect(reverse("{{ model }}_list"))
